使用标准方式在 Ubuntu 16.04 下启用 TCP 拥塞控制之 BBR

我是这 Ubuntu Server 系列文章的第二篇,讲讲如何在 Ubuntu 16.04 LTS 下通过最标准的方式启用 TCP 拥塞控制之 BBR。

BBR 简介

BBR 是 Google 推出的一个「TCP 拥塞控制算法」,它是以 Linux 内核模块的形式加载,可以最大化 Linux Server 的网络吞吐量。

简单地说,开启 BBR 的 Linux Server 和不开启 BBR 的 Linux Server,在持续传输数据方面可以有非常大的不同。这个技术非常合适应用在视频、下载网站上,个人的话,当然是科学上网了。

BBR 尽管还没有在主流发行版中默认开启,但 Google 已经在 YouTube 网站上实践了很久,可以说是很成熟的一样技术了。

下面我就介绍一下我是如何在 Ubuntu 16.04 上使用最标准的方式来开启 BBR 支持的。

如何检测 BBR 是否开启

在开始之前,我们可以先看看 BBR 是否已经启用了(没准你用的云主机商已经做了这件事情):

执行这条指令可以返回当前 Linux 内核可以使用的 TCP 拥堵控制算法:

sysctl net.ipv4.tcp_available_congestion_control

在我的 Server 上,返回了:

net.ipv4.tcp_available_congestion_control = cubic reno

很明显,默认的 Ubuntu 16.04 用的是 Linux 4.4.0 内核,自然是看不到 BBR 的。

我们再确认一次当前使用的控制算法:

sysctl net.ipv4.tcp_congestion_control

返回内容是:

net.ipv4.tcp_congestion_control = cubic

没错,就是使用 cubic 这个默认的算法。接下去我们通过最标准的模式来为这台 Ubuntu 16.04 启用 BBR。

为 Ubuntu 16.04 安装 4.10 + 新内核

如果你简单地了解过 BBR,那么就知道 BBR 只能配合 Linux Kernel 4.10 以上内核才能使用。但是在 Ubuntu 16.04 上怎么使用 4.10 呢?难道要手动下载和安装吗?

不能!这会有一个安全隐患,手动下载安装的新内核,无法保证后续能得到及时的安全更新。那么怎么办?这里我推荐使用 HWE 版本的内核,它就在官方源里。

HWE,即:HareWare Enablement,是专门为在老的系统上支持新的硬件而推出的内核。你可以像安装其他软件包一样在 Ubuntu 16.04 里非常容易的安装它:

sudo apt-get install linux-generic-hwe-16.04

只要这样,就 OK 了…是不是超简单?这里还有一个 Tips:假如你想使用更激进的新内核,可以使用 edge 版本:

sudo apt-get install linux-generic-hwe-16.04-edge

这两个软件包不同的是,前一个安装的是 4.10 内核,后一个安装的是 4.11,充分满足想追求使用新内核的同学的需求。

安装好以后重启电脑,然后输入:

uname -a

看看是不是变成 4.10 内核了?

Linux hostname 4.10.0-33-generic

为 Ubuntu 16.04 启用 BBR

有了新内核以后,我们就可以为新内核装载 BBR 模块了:

sudo modprobe tcp_bbr

echo "tcp_bbr" | sudo tee -a /etc/modules-load.d/modules.conf

装载后,再执行 sysctl net.ipv4.tcp_available_congestion_control 命令,你就可以看到 BBR 出现在输出结果里了。

接下去再正式启用它:

echo "net.core.default_qdisc=fq" | sudo tee -a /etc/sysctl.conf

echo "net.ipv4.tcp_congestion_control=bbr" | sudo tee -a /etc/sysctl.conf

sudo sysctl -p

执行完这几条指令后,再用 sysctl net.ipv4.tcp_congestion_control 验证一下,看到返回结果是:

net.ipv4.tcp_congestion_control = bbr

It works!

总结

在为我们的系统启用各种新特性的情况下,我看到网络上很多教材都是去下载一些独立的内核软件包、甚至有教程教用户自己去编译内核模块…这不但麻烦,而且带来很大的维护成本,所以我不推荐这种方式。希望本文的方式能成为接下去大家都会去使用的一种方式。

对了,大家启用 BBR 前后,记得通过下载测个速,你就会发现前后的改变是非常显著的。

<推广> 本站架设于 Linode 东京机房

6 Comments

  1. 搬瓦工的Ubuntu虽然可选16.04,但内核都是2.6的,既不能用Docker,也没有TCP_FAST_OPEN,更别说BBR。体验不到,甚是遗憾。

    • 啥,搬瓦工可以用 BBR 啊,就用我这样的方式。可能你用的不是 KVM 版本。

      • 汗,我一直以为这种基于内核虚拟出来的VPS是不能更新内核的……
        话说HWE的全称写错了,HardWare Enablement写成HareWare Enablement了。

      • 在搬瓦工上的机器试了一下,执行
        `apt-get install linux-generic-hwe-16.04`,
        可以安装成功,但是 `uname -r` 仍然是 `2.6.32-042stab123.3`。

        在自己本地桌面实体机上是可以成功的,我甚至都没更新 xserver,`uname -r` 都可以达到 `4.10.0-33-generic`。
        在虚拟机里的服务器里也正常。

        仔细注意了一下,发现主机购买记录上写着OVZ+KVM Panel……搞了半天是OpenVZ的主机,搬瓦工的管理面板叫KiwiVM。

        我还以为用HWE就能在廉价主机上享受一把Docker了呢,也是白高兴一场。

  2. 搬瓦工 CN2,KVM,系统:Ubuntu 16.04.2 LTS,内核:4.4.0-96-generic。修改内核那一步出错了,求解。
    Input:
    sudo apt-get install linux-generic-hwe-16.04

    Output:
    Reading package lists...
    Building dependency tree...
    Reading state information...
    You might want to run 'apt-get -f install' to correct these:
    The following packages have unmet dependencies:
    linux-generic : Depends: linux-headers-generic (= 4.4.0.96.101) but 4.4.0.93.98 is to be installed
    linux-generic-hwe-16.04 : Depends: linux-image-generic-hwe-16.04 (= 4.10.0.35.37) but it is not going to be installed
    Depends: linux-headers-generic-hwe-16.04 (= 4.10.0.35.37) but it is not going to be installed
    E: Unmet dependencies. Try 'apt-get -f install' with no packages (or specify a solution).
    Exit code: 100

Leave a Comment